Summary:          Thread pool based event framework wrapper
Name:             nunc-stans
Version:          0.2.0
Release:          1%{?dist}
License:          GPLv3+
URL:              http://fedorahosted.org/nunc-stans
Group:            Development/Libraries
BuildRequires:    nspr-devel
BuildRequires:    libtevent-devel
BuildRequires:    libtalloc-devel
BuildRequires:    libevent-devel
BuildRequires:    libcmocka-devel

Source0:          https://git.fedorahosted.org/cgit/nunc-stans.git/snapshot/%{name}-%{version}.tar.xz
#Source0:          http://fedorahosted.org/sources/%{name}-%{version}.tar.xz

%description
%{name} is an event framework wrapper that provides a thread pool for event
callback execution.  It provides thread safety to event frameworks by isolating
and protecting the thread safe parts from the non-thread safe parts, and allows
multi-threaded applications to use event frameworks that are not thread safe.
It has been primarily developed using [libevent](http://libevent.org "libevent
home page") , but has also been tested with [tevent](https://tevent.samba.org
"tevent home page").   %{name} uses lock free data structures where possible,
to avoid mutex contention. The ​[liblfds](http://liblfds.org "Lock Free Data Structure")
library is used. 

%package devel
Summary:  Development and header files for %{name}
Group:    Development/Libraries
Requires: %{name} = %{version}-%{release}
Requires: pkgconfig
Requires: nspr-devel

%description devel
Development files and header files necessary to build applications
that use %{name}.

%prep
%setup -q

%build

%configure
make

%install
%{__rm} -rf $RPM_BUILD_ROOT

%{__make} install DESTDIR=$RPM_BUILD_ROOT INSTALL="%{__install} -p"
%{__rm} -f $RPM_BUILD_ROOT%{_libdir}/lib*.a
%{__rm} -f $RPM_BUILD_ROOT%{_libdir}/lib*.la

%clean
%{__rm} -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%files
%defattr(-,root,root,-)
%doc COPYING COPYING.openssl COPYING.liblfds LICENSE.md
%{_libdir}/*.so.*

%files devel
%defattr(-,root,root,-)
%{_libdir}/pkgconfig/%{name}.pc
%{_libdir}/*.so
%{_includedir}/nunc-stans
%{_pkgdocdir}
%{_mandir}

%changelog
* Wed Oct 6 2016 William Brown <wibrown@redhat.com> - 0.2.0-1
- Fix get set valid states.
- Remove ns_job_modify.
- Segfault in thr_stack_create.
- Convert barriers to monitor on job.
- Remove the thread pool scaleup / down skeleton.
- Remove unnecessary counters from jobs.
- Fix nuncstans spec file.
- Upgrade liblfds to 710.
- Heap use after free in ns_job_done.
- Add stress test.
- Ability to disarm a persistent job from within it's callback.
- ns_job_modify should not rearm.
- Update the configure and autotools files.
- Implement a strict state machine for nunc-stans jobs.
- Move job done callback.
- Job rearm should ignore if ns_persist is set.
- Job done callback.
- Add ns_job_set_data helper.
- pkgconfig missing -L option.

* Thu Sep 22 2016 William Brown <wibrown@redhat.com> - 0.1.8-1
- Update specfile for new libraries
- Update of configure tools to build lfdsXXX.so rather than built in
- Bug fixes and stability updates

* Mon May  4 2015 Rich Megginson <rmeggins@redhat.com> - 0.1.1-1
- Initial commit
